package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 100;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<Entry>();
        }
    }

    @Override
    public int size() {
        int size = 0;

        for(List list : entries){
            size += list.size();
        }

        return size;
    }

    @Override
    public boolean isEmptry() {

        if(size() == 0){
            return true;
        }

        return false;
    }

    @Override
    public Cart get(User key) {

        for(int i = 0; i < entries.length; i ++){
            for(int m = 0; m < entries[i].size(); m ++){
                Entry entry = entries[i].get(m);
                if(entry.getKey().equals(key)){
                    return entry.getValue();
                }
            }
        }

        return null;
    }

    @Override
    public void put(User key, Cart value) {
        int index = bucketIndex(key);
        boolean added = false;

        List list = entries[index];

        if(list.size() != 0) {
            for (int i = 0; i < list.size(); i++) {
                if (((Entry) list.get(i)).getKey().equals(key)) {
                    Entry entry = (Entry) list.get(i);
                    list.remove(entry);
                    list.add(new Entry(key, value));
                    added = true;
                }
            }
        }
        if(!added) {
            entries[index].add(new Entry(key, value));
        }
    }

    @Override
    public List<User> getKeys() {
        List<User> users = new ArrayList<>();

        for(int i = 0; i < entries.length; i ++){
            List list = entries[i];
            for(int m = 0; m < list.size(); m ++){
                Entry entry = (Entry) list.get(m);
                users.add(entry.getKey());
            }
        }
        return users;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> carts = new ArrayList<>();

        for(int i = 0; i < entries.length; i ++){
            List list = entries[i];
            for(int m = 0; m < list.size(); m ++){
                Entry entry = (Entry) list.get(m);
                carts.add(entry.getValue());
            }
        }
        return carts;
    }

    @Override
    public Cart remove(User key) {

        Cart removeCart = null;

        for(int i = 0; i < entries.length; i ++){
            List list = entries[i];
            for(int m = 0; m < list.size(); m ++){
                Entry entry = (Entry) (list.get(m));
                if(entry.getKey().equals(key)){
                    removeCart = entry.getValue();
                    list.remove(entry);
                }
            }
        }
        return removeCart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
